ARCboot<-function(b, Bootmatrix, prep_boot,NobARC)
{ 
  ubootsamp  <- prep_boot[[2]]
  datagrade1 <- prep_boot[[3]]
  datagrade2 <- prep_boot[[4]]
  vecprefboot <- prep_boot[[6]]
  datapref   <- prep_boot[[7]]
# the bootstrap parameters
PARgrade <- list(Bootmatrix[,b][1:12],Bootmatrix[,b][13:21],(Bootmatrix[,b][21]+2/3)) 
#  getting the deltas  
bpref <- Bootmatrix[,b][22:32]

epsdat <- datagrade2[,7]

delta10 <- 1/(1+exp(-cbind(rep(1,nobs), epsdat) %*% bpref[1:ndt]))
delta11 <- (1-delta10)/(1+exp(-cbind(rep(1,nobs), epsdat) %*% bpref[(ndt+1):(2*ndt)]))
delta01 <- 1-delta10 -delta11
#  the matrix of Deltas for each individual
DT <- cbind(delta10, delta11, delta01)

########################################################################################
#================= parameters for simulations and bootstrap   ==========================
########################################################################################
#  the parameters
gamma <- bpref[5:(ndt*2+na)]
#  the log utility difference  
logvdiff <- as.matrix(cbind(rep(1,nobs), datapref))%*%gamma
#  the vectors needed for boostrap 
vecpref<-cbind(logvdiff,DT,vecprefboot[,5:6])

m1boot <- as.vector(as.matrix(cbind(rep(1,nobs), datagrade1)) %*% PARgrade[[1]])
m2boot <- as.vector(as.matrix(cbind(rep(1,nobs), datagrade2)) %*% PARgrade[[2]][1:8])   
mft <- cbind(m1boot, m2boot)


# random conponents
nsimul <- NobARC  # number random draws for the converging algorithm
#  preference shock, once drawn, fix across all the iterations 
eps1ct <-  runif(nobs)     #----- random draws for choice proportions
eps2ct <-  runif(nobs)     #----- random draws for preference difference

# grade shocks, drawn from the empirical distributions with replacement. 
u1ct <- matrix(rep(0), nrow = nobs, ncol = nsimul)  
for (i in 1:nsimul)
{
  u1ct[,i] <- sample(ubootsamp[[1]], size = nobs, replace=TRUE)
}   
u2ct <- matrix(rep(0), nrow = nobs, ncol = nsimul)
for (i in 1:nsimul)
{
  u2ct[,i] <- sample(ubootsamp[[2]],size = nobs, replace=TRUE)    
}
# for prob resim
simul <- matrix(runif(nobs*nsim), nrow = nobs)   #random draw from uniform distribution

# resim the counterfactual 
bootresARC <- FUNsysARC(eps1ct,eps2ct,u1ct,u2ct,mft, PARgrade, vecpref,ubootsamp,NobARC)


# the convergent thresholds 
THRESHsysARC <- bootresARC[[1]]
THRESHsysARC <- THRESHsysARC[THRESHsysARC[,1]!=0,]

# check convergence
CONVGARC <- bootresARC[[2]]
CONVGARC <- CONVGARC[CONVGARC!=0]

# the convergent success probabilities  
PSIMARC  <- bootresARC[[5]]

# the choice of the programs
dARC <- bootresARC[[6]]

# RE-simulate the counterfactual system to get the distributions of thresholds 
simulARC <- matrix(runif(nobs*nsimT), nrow = nobs)   #random draw from uniform distribution

# data for simulation of thresholds
datsimARC <- list(dARC, mft[,1], mft[,2])

# simulated thresholds 
TSIMARCRESIM <- FUNresimARC(datsimARC,nsimT,ubootsamp,simulARC,PARgrade)
TARC <- apply(TSIMARCRESIM, 2, mean)
TARCsd <- apply(TSIMARCRESIM, 2, sd)

return(c(TARC,TARCsd,length(CONVGARC)))
}




