# The functions of computing the success probabilities
# Version of Feburary 05 2014

# Simulation of success probabilities
sucprob <- function(b,uboot,simul,cfu1) { 
  
  nobs<-length(uboot[[1]])
  nobsm2<-length(uboot[[2]])
  u1o<-sort(uboot[[1]])
  u2o<-sort(uboot[[2]])
  
  # Probability of passing first exam
  im1 <- findInterval(b[,1], u1o)      # Ranking      
  pm1 <- (nobs+1-im1)/(nobs+1)            
  
  # Drawing in distribution of u1
  im1s <- cbind(im1, simul)
  u1s <- t(apply(im1s, 1, function(x) u1o[ceiling(x[-1]*(nobs-x[1])) + x[1]]))   # Random draw
  
  # Evaluating the success probability conditional on u1
  im2s <- apply(b[,2] - cfu1*u1s, 2, function(x) findInterval(x, u2o))  # Ranking      
  pm2 <- (nobsm2+1-apply(im2s,1,mean))/(nobsm2+1)            # Probability of being above the lower bound
  
  # Simulated success probability
  cbind(pm1, pm1*pm2)
}


#the star probability, cross probility 
sucprobstar<-function(b)
  
{
  # Probability of passing first exam
  im1 <- findInterval(b[,1], u1o)      # Ranking      
  pm1 <- (nobs+1-im1)/(nobs+1)            
  
  # Drawing in distribution of u1
  im1s <- cbind(im1, simul )
  u1s <- t(apply(im1s, 1, function(x) u1o[ceiling(x[-1]*(nobs-x[1])) + x[1]]))   # Random draw
  
  # Evaluating the success probability conditional on u1
  im2s <- apply(b[,2] - cfu1*u1s, 2, function(x) findInterval(x, u2o))  # Ranking      
  pm2 <- (nobsm2+1-apply(im2s,1,mean))/(nobsm2+1)            # Probability of being above the lower bound
  
  # Simulated success probability
  pm1*pm2
  
}

# timing change success probability computation
sucprobTM <- function(bm10,bm20) { 
  
  # Probability of passing first exam
  im1 <- findInterval(bm10, u1o)      # Ranking      
  pm1 <- (nobs+1-im1)/(nobs+1)            
  
  # Drawing in distribution of u1
  im1s <- cbind(im1, simul)
  u1s <- t(apply(im1s, 1, function(x) u1o[ceiling(x[-1]*(nobs-x[1])) + x[1]]))   # Random draw
  
  # Evaluating the success probability conditional on u1
  im2s <- apply(bm20  - cfu1*u1s, 2, function(x) findInterval(x, u2o))  # Ranking      
  pm2 <- (nobsm2+1-apply(im2s,1,mean))/(nobsm2+1)            # Probability of being above the lower bound
  
  # Simulated success probability
  cbind(pm2)
}

# For timing change success probability computation of utility change 
sucprobTMutil <- function(u1,u2) { 
  
  # Probability of passing first exam
  im1 <- findInterval(bm10, u1o)      # Ranking      
  pm1 <- (nobs+1-im1)/(nobs+1)            
  
  # Drawing in distribution of u1
  im1s <- cbind(im1, simul)
  u1s <- t(apply(im1s, 1, function(x) u1o[ceiling(x[-1]*(nobs-x[1])) + x[1]]))   # Random draw
  
  # Evaluating the success probability conditional on u1
  im2s <- apply(bm20  - cfu1*u1s, 2, function(x) findInterval(x, u2o))  # Ranking      
  pm2 <- (nobsm2+1-apply(im2s,1,mean))/(nobsm2+1)            # Probability of being above the lower bound
  
  # Simulated success probability
  cbind(pm2)
}

